/*
 * MontyHall.java
 * This codes is released under Gnu General Public License (GPL)
 *
 * Created on 09 December 2004
 */

package net.unverkaeuflich.feuerhake.montyhall;

/**
 * this class models Monty in the MontyHallProblem
 * @author  joerg
 */
import net.unverkaeuflich.feuerhake.montyhall.util.RandomHelper;
public class MontyHall {
    private int doorChosen = -1;
    private MontyDoors Doors = null;
    private int doorChosenByCand = -1;
    /** Creates a new instance of MontyHall */
    private MontyHall() {
        Doors = new MontyDoors();
    }
    /** Creates a new instance of MontyHall */
    public MontyHall(MontyDoors newDoors, int newValue) {
        chooseDoor();
        Doors = newDoors;
        doorChosenByCand = newValue;
    }
    /**
     * choose a random number to determine which door to open
     */
    private void chooseDoor(){
        doorChosen = RandomHelper.getRandomNumber(2);
        return;
    }
    /**
     * this method opens the door, methaphorically
     */
    public int openDoor(){
        int[] ia = new int[2];
        
        //the candidate has not chosen the door with the car.
        //there is only one door i can open
        if(doorChosenByCand != Doors.getCarDoor()){
            //there is only one door, we could open, which one?
            if(0!=doorChosenByCand && 0 != Doors.getCarDoor())
                return 0;
            if(1!=doorChosenByCand && 1 != Doors.getCarDoor())
                return 1;
            if(2!=doorChosenByCand && 2 != Doors.getCarDoor())
                return 2;
            return -1;
            
        }
        else{
            //the candidate chose the door with the car
            //monty has to doors he could open
            int j = 0;
            for(int i=0; i<3; i++){
                if(i != doorChosenByCand){
                    ia[j] = i;
                    j++;
                };
            };
            
        };
        return ia[doorChosen];
    }
    
}
